#!/usr/bin/python
#coding: utf-8

from PyQt4.QtCore import Qt, QString, QSizeF, SIGNAL
from PyKDE4.kdecore import KToolInvocation
from PyQt4.QtGui import QGraphicsLinearLayout
from PyKDE4.plasma import Plasma
from PyKDE4 import plasmascript
import sys, subprocess, os, pwd, grp

class Edubar(plasmascript.Applet):
    def __init__(self,parent,args=None):
        plasmascript.Applet.__init__(self,parent)

    def createIcon(self, imagefile, size, widget=None):

        obj = Plasma.IconWidget()
        obj.setIcon(QString(imagefile))

        obj.setMinimumSize(QSizeF(size,size))

        return obj

    def launchBrowser(self, link):
        """ Open browser using 'link' as parameter. """

        KToolInvocation.invokeBrowser(link)

    def hDomain(self):
        self.launchBrowser("http://www.dominiopublico.gov.br/")

    def hSchool(self):
        self.launchBrowser("http://tvescola.mec.gov.br/")

    def hObjects(self):
        self.launchBrowser("http://objetoseducacionais2.mec.gov.br/")

    def hTeacher(self):
        self.launchBrowser("http://portaldoprofessor.mec.gov.br/")

    def imgPathFromFile(self,imgFile):
        imagespath = self.applet.package().path() + "contents/imgs/"
        return imagespath + imgFile

    def _runCmd(self, cmd):
        """ Run cmd and return a tuple (retcode, output) """

        s = subprocess.Popen(cmd, stdout=subprocess.PIPE,
                             stderr=subprocess.PIPE, shell=True)

        # FIXME: Find out why s.wait() freezes sometimes
        #retcode = s.wait()
        output = s.communicate()
        #if retcode == 0:
        #    output = output[0].split("\n")
        #else:
        #    output = output[1]
        try:
            output = output[0].split("\n")
        except:
            output = []
        retcode = 0

        return (retcode,output)


    def logMsg(self, msg):
        sys.stderr.write("LOG: %s\n" % msg)

    def getScreenGeometry(self):
        """ Return screen geometry in QSize format"""

        return self.applet.scene().screenGeometry(0)

    def imAdmin(self):
        """ Check if the current user is member of admin group.
            return True is he is, and False otherwise """

        login = pwd.getpwuid(os.geteuid()).pw_name
        if login in grp.getgrnam("admin").gr_mem:
            return True
        else:
            return False

    def init(self):

        self.setHasConfigurationInterface(False)
        self.setAspectRatioMode(Plasma.IgnoreAspectRatio)
        self.setBackgroundHints(Plasma.Applet.NoBackground)

        mlayout = QGraphicsLinearLayout(Qt.Horizontal, self.applet)
        mlayout.setSpacing(0)

        iDict = {"domain": {"handler":self.hDomain, "img":"1.png", "label": "Dominio Publico" },
                 "school": {"handler":self.hSchool, "img":"2.png", "label": "TV Escola" },
                 "teacher": {"handler":self.hTeacher, "img":"3.png", "label": "Portal do Professor" },
                 "objects": {"handler":self.hObjects, "img":"4.png", "label": "Objetos Educacionais" },
                }

        icons = [iDict["domain"], iDict["school"], iDict["teacher"],
                  iDict["objects"]]

        # Get the screen size and calculate the icon size
        width = self.getScreenGeometry().width()

        if width < 1024:
            wsize = 96
        else:
            wsize = 128

        for iDesc in icons:
            icon = self.createIcon(self.imgPathFromFile(iDesc["img"]),wsize)
            icon.setToolTip ( iDesc["label"] )
            icon.connect(icon,SIGNAL("clicked()"),iDesc["handler"])

            mlayout.addItem(icon)

        self.applet.setLayout(mlayout)
        self.resize(len(icons)*wsize,wsize)

def CreateApplet(parent):
    return Edubar(parent)
